#ifndef NAMED_COUNTER_FACTORY__INCLUDED
#define NAMED_COUNTER_FACTORY__INCLUDED

#include "RefCount.h"

#include "NamedCounter.h"
#include <map>

class NamedCounterFactoryImpl :
   public virtual POA_NamedCounterFactory,
	public virtual PortableServer::RefCountServantBase
{
   public :
      
      NamedCounterFactoryImpl();
      ~NamedCounterFactoryImpl();

      // implement the interface

      virtual NamedCounter_ptr GetNamedCounter(
         const char* name);

      virtual void AddNamedCounter(
         const char* name, 
         CORBA::Long initialValue);
  
      virtual void RemoveNamedCounter(
         const char* name);

      virtual NamedCounterFactory::counterSeq *GetAll();
  
   private :

      typedef std::map<std::string, NamedCounterImpl *> CounterContainer;

      CounterContainer m_counters;

      // do not implement - restrict copying
      NamedCounterFactoryImpl(const NamedCounterFactoryImpl &rhs);
      NamedCounterFactoryImpl &operator =(const NamedCounterFactoryImpl &rhs);
};

#endif NAMED_COUNTER_FACTORY__INCLUDED